=== modified file '.bzrignore'
--- .bzrignore	2009-04-01 14:40:05 +0000
+++ .bzrignore	2009-02-10 01:57:06 +0000
@@ -6,4 +6,3 @@
 build
 *.log
 _trial_temp
-loggerhead-memprofile

=== modified file 'NEWS'
--- NEWS	2009-04-16 21:49:48 +0000
+++ NEWS	2009-03-04 21:02:14 +0000
@@ -5,7 +5,7 @@
 ---------------
 
     - Loggerhead now serves bzr branches over HTTP and exposes the URL
-      to branch them. Addresses bug #240577. (Jonathan Lange)
+      to branch them. (Jonathan Lange)
 
     - Leading blank lines in commit messages no longer result in an
       empty summary. (Colin Watson)
@@ -43,12 +43,6 @@
     - Changelog messages are now displayed with newlines preserved.
       (Peter Bui)
 
-    - serve-branches now has an option, --use-cdn, to load YUI from
-      Yahoo!'s CDN. (Matt Nordhoff)
-
-    - Fix bug #361238 (serve-branches was calling config.get_option()
-      incorrectly and failing). (Matt Nordhoff)
-
 1.10 [22Dec2008]
 ---------------
 

=== modified file 'README.txt'
--- README.txt	2009-03-17 22:31:42 +0000
+++ README.txt	2009-03-10 01:05:08 +0000
@@ -11,19 +11,15 @@
 GETTING STARTED
 ---------------
 
-Loggerhead depends on:
-
+Loggerhead depends on 
 1) SimpleTAL for templating.
-   On Ubuntu, `sudo apt-get install python-simpletal`
+   on Ubuntu package `sudo apt-get install python-simpletal`
    or download from http://www.owlfish.com/software/simpleTAL/download.html
-2) simplejson for producing JSON data.
-   On Ubuntu, `sudo apt-get install python-simplejson`
-   or use `easy_install simplejson`.
-3) Paste for the server. (You need version 1.2 or newer of Paste.)
-   On Ubuntu, `sudo apt-get install python-paste`
+2) Paste for the server. (You need version 1.2 or newer of Paste.) 
+   on Ubuntu package `sudo apt-get install python-paste`
    or use `easy_install Paste`
-4) Paste Deploy  (optional, needed when proxying through Apache)
-   On Ubuntu, `sudo apt-get install python-pastedeploy`
+3) Paste Deploy  (optional, needed when proxying through Apache)
+   on Ubuntu package `sudo apt-get install python-pastedeploy`
    or use `easy_install PasteDeploy`
 
 Then simply run the 'serve-branches' with the branch you want to

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-04-07 18:29:10 +0000
+++ loggerhead/apps/branch.py	2009-02-18 10:36:48 +0000
@@ -11,16 +11,14 @@
 from paste import httpexceptions
 
 from loggerhead.apps import static_app
+from loggerhead.controllers.changelog_ui import ChangeLogUI
+from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.annotate_ui import AnnotateUI
+from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.atom_ui import AtomUI
-from loggerhead.controllers.changelog_ui import ChangeLogUI
-from loggerhead.controllers.diff_ui import DiffUI
 from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.controllers.filediff_ui import FileDiffUI
-from loggerhead.controllers.inventory_ui import InventoryUI
-from loggerhead.controllers.revision_ui import RevisionUI
-from loggerhead.controllers.revlog_ui import RevLogUI
 from loggerhead.controllers.search_ui import SearchUI
+from loggerhead.controllers.diff_ui import DiffUI
 from loggerhead.history import History
 from loggerhead import util
 
@@ -31,7 +29,7 @@
 
     def __init__(self, branch, friendly_name=None, config={},
                  graph_cache=None, branch_link=None, is_root=False,
-                 served_url=_DEFAULT, use_cdn=False):
+                 served_url=_DEFAULT):
         self.branch = branch
         self._config = config
         self.friendly_name = friendly_name
@@ -42,7 +40,6 @@
         self.graph_cache = graph_cache
         self.is_root = is_root
         self.served_url = served_url
-        self.use_cdn = use_cdn
 
     def get_history(self):
         _history = History(self.branch, self.graph_cache)
@@ -80,24 +77,15 @@
     def static_url(self, path):
         return self._static_url_base + path
 
-    def yui_url(self, path):
-        if self.use_cdn:
-            base = 'http://yui.yahooapis.com/3.0.0pr2/build/'
-        else:
-            base = self.static_url('/static/javascript/yui/build/')
-        return base + path
-
     controllers_dict = {
-        '+filediff': FileDiffUI,
-        '+revlog': RevLogUI,
         'annotate': AnnotateUI,
-        'atom': AtomUI,
         'changes': ChangeLogUI,
-        'diff': DiffUI,
-        'download': DownloadUI,
         'files': InventoryUI,
         'revision': RevisionUI,
+        'download': DownloadUI,
+        'atom': AtomUI,
         'search': SearchUI,
+        'diff': DiffUI,
         }
 
     def last_updated(self):

=== modified file 'loggerhead/apps/filesystem.py'
--- loggerhead/apps/filesystem.py	2009-04-23 23:39:18 +0000
+++ loggerhead/apps/filesystem.py	2009-02-19 18:04:11 +0000
@@ -1,6 +1,7 @@
 """Serve branches at urls that mimic the file system layout."""
 
 import os
+import tempfile
 
 from bzrlib import branch, errors, lru_cache
 
@@ -10,9 +11,10 @@
 
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.apps import favicon_app, static_app
-from loggerhead.config import LoggerheadConfig
 from loggerhead.controllers.directory_ui import DirectoryUI
 
+sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
+
 
 class BranchesFromFileSystemServer(object):
 
@@ -20,7 +22,6 @@
         self.path = path
         self.root = root
         self.name = name
-        self._config = root._config
 
     def app_for_branch(self, branch):
         if not self.name:
@@ -30,10 +31,8 @@
             name = self.name
             is_root = False
         branch_app = BranchWSGIApp(
-            branch, name,
-            {'cachepath': self._config.SQL_DIR},
-            self.root.graph_cache, is_root=is_root,
-            use_cdn=self._config.get_option('use_cdn'))
+            branch, name, {'cachepath': sql_dir}, self.root.graph_cache,
+            is_root=is_root)
         return branch_app.app
 
     def app_for_non_branch(self, environ):
@@ -70,10 +69,9 @@
 
 class BranchesFromFileSystemRoot(object):
 
-    def __init__(self, folder, config):
+    def __init__(self, folder):
         self.graph_cache = lru_cache.LRUCache()
         self.folder = folder
-        self._config = config
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
@@ -93,15 +91,14 @@
 
 class UserBranchesFromFileSystemRoot(object):
 
-    def __init__(self, folder, config):
+    def __init__(self, folder, trunk_dir):
         self.graph_cache = lru_cache.LRUCache()
         self.folder = folder
-        self._config = config
-        self.trunk_dir = config.get_option('trunk_dir')
+        self.trunk_dir = trunk_dir
 
     def __call__(self, environ, start_response):
         environ['loggerhead.static.url'] = environ['SCRIPT_NAME']
-        path_info = environ['PATH_INFO']
+        path_info= environ['PATH_INFO']
         if path_info.startswith('/static/'):
             segment = path_info_pop(environ)
             assert segment == 'static'

=== modified file 'loggerhead/changecache.py'
--- loggerhead/changecache.py	2009-03-19 21:01:11 +0000
+++ loggerhead/changecache.py	2008-10-24 02:26:05 +0000
@@ -17,10 +17,9 @@
 #
 
 """
-a cache for chewed-up 'file change' data structures, which are basically just
-a different way of storing a revision delta.  the cache improves lookup times
-10x over bazaar's xml revision structure, though, so currently still worth
-doing.
+a cache for chewed-up "change" data structures, which are basically just a
+different way of storing a revision.  the cache improves lookup times 10x
+over bazaar's xml revision structure, though, so currently still worth doing.
 
 once a revision is committed in bazaar, it never changes, so once we have
 cached a change, it's good forever.
@@ -28,40 +27,36 @@
 
 import cPickle
 import os
-import tempfile
+
+from loggerhead import util
+from loggerhead.lockfile import LockFile
+
+with_lock = util.with_lock('_lock', 'ChangeCache')
 
 try:
     from sqlite3 import dbapi2
 except ImportError:
     from pysqlite2 import dbapi2
 
-# We take an optimistic approach to concurrency here: we might do work twice
-# in the case of races, but not crash or corrupt data.
 
 class FakeShelf(object):
 
     def __init__(self, filename):
         create_table = not os.path.exists(filename)
-        if create_table:
-            # To avoid races around creating the database, we create the db in
-            # a temporary file and rename it into the ultimate location.
-            fd, path = tempfile.mkstemp(dir=os.path.dirname(filename))
-            self._create_table(path)
-            os.rename(path, filename)
         self.connection = dbapi2.connect(filename)
         self.cursor = self.connection.cursor()
+        if create_table:
+            self._create_table()
 
-    def _create_table(self, filename):
-        con = dbapi2.connect(filename)
-        cur = con.cursor()
-        cur.execute(
+    def _create_table(self):
+        self.cursor.execute(
             "create table RevisionData "
             "(revid binary primary key, data binary)")
-        con.commit()
-        con.close()
+        self.connection.commit()
 
     def _serialize(self, obj):
-        return dbapi2.Binary(cPickle.dumps(obj, protocol=2))
+        r = dbapi2.Binary(cPickle.dumps(obj, protocol=2))
+        return r
 
     def _unserialize(self, data):
         return cPickle.loads(str(data))
@@ -75,16 +70,12 @@
         else:
             return self._unserialize(filechange[0])
 
-    def add(self, revid, object):
-        try:
+    def add(self, revid_obj_pairs):
+        for (r, d) in revid_obj_pairs:
             self.cursor.execute(
                 "insert into revisiondata (revid, data) values (?, ?)",
-                (revid, self._serialize(object)))
-            self.connection.commit()
-        except dbapi2.IntegrityError:
-            # If another thread or process attempted to set the same key, we
-            # assume it set it to the same value and carry on with our day.
-            pass
+                (r, self._serialize(d)))
+        self.connection.commit()
 
 
 class FileChangeCache(object):
@@ -97,10 +88,31 @@
 
         self._changes_filename = os.path.join(cache_path, 'filechanges.sql')
 
-    def get_file_changes(self, entry):
+        # use a lockfile since the cache folder could be shared across
+        # different processes.
+        self._lock = LockFile(os.path.join(cache_path, 'filechange-lock'))
+
+    @with_lock
+    def get_file_changes(self, entries):
+        out = []
+        missing_entries = []
+        missing_entry_indices = []
         cache = FakeShelf(self._changes_filename)
-        changes = cache.get(entry.revid)
-        if changes is None:
-            changes = self.history.get_file_changes_uncached(entry)
-            cache.add(entry.revid, changes)
-        return changes
+        for entry in entries:
+            changes = cache.get(entry.revid)
+            if changes is not None:
+                out.append(changes)
+            else:
+                missing_entries.append(entry)
+                missing_entry_indices.append(len(out))
+                out.append(None)
+        if missing_entries:
+            missing_changes = self.history.get_file_changes_uncached(
+                                  missing_entries)
+            revid_changes_pairs = []
+            for i, entry, changes in zip(
+                missing_entry_indices, missing_entries, missing_changes):
+                revid_changes_pairs.append((entry.revid, changes))
+                out[i] = changes
+            cache.add(revid_changes_pairs)
+        return out

=== removed file 'loggerhead/config.py'
--- loggerhead/config.py	2009-04-16 22:28:17 +0000
+++ loggerhead/config.py	1970-01-01 00:00:00 +0000
@@ -1,83 +0,0 @@
-'''Configuration tools for Loggerhead.'''
-from optparse import OptionParser
-import sys
-import tempfile
-
-
-_temporary_sql_dir = None
-
-def _get_temporary_sql_dir():
-    global _temporary_sql_dir
-    if _temporary_sql_dir is None:
-        _temporary_sql_dir = tempfile.mkdtemp(prefix='loggerhead-cache-')
-    return _temporary_sql_dir
-
-def command_line_parser():
-    parser = OptionParser("%prog [options] <path>")
-    parser.set_defaults(
-        user_dirs=False,
-        show_version=False,
-        log_folder=None,
-        use_cdn=False,
-        sql_dir=None,
-        )
-    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
-                      help="Serve user directories as ~user.")
-    parser.add_option("--trunk-dir", metavar="DIR",
-                      help="The directory that contains the trunk branches.")
-    parser.add_option("--port", dest="user_port",
-                      help=("Port Loggerhead should listen on "
-                            "(defaults to 8080)."))
-    parser.add_option("--host", dest="user_host",
-                      help="Host Loggerhead should listen on.")
-    parser.add_option('--memory-profile', action='store_true',
-                      dest='memory_profile',
-                      help='Profile the memory usage using heapy.')
-    parser.add_option("--prefix", dest="user_prefix",
-                      help="Specify host prefix.")
-    parser.add_option("--profile", action="store_true", dest="profile",
-                      help="Generate callgrind profile data to "
-                        "%d-stats.callgrind on each request.")
-    parser.add_option("--reload", action="store_true", dest="reload",
-                      help="Restarts the application when changing python"
-                           " files. Only used for development purposes.")
-    parser.add_option('--log-folder', dest="log_folder",
-                      type=str, help="The directory to place log files in.")
-    parser.add_option("--version", action="store_true", dest="show_version",
-                      help="Print the software version and exit")
-    parser.add_option('--use-cdn', action='store_true',
-                      help="Serve YUI from Yahoo!'s CDN")
-    parser.add_option('--cache-dir', dest='sql_dir',
-                      help="The directory to place the SQL cache in")
-    return parser
-
-
-class LoggerheadConfig(object):
-    '''A configuration object.'''
-
-    def __init__(self):
-        self._parser = command_line_parser()
-        self._options, self._args = self._parser.parse_args(sys.argv[1:])
-
-        sql_dir = self.get_option('sql_dir')
-        if sql_dir is None:
-            sql_dir = _get_temporary_sql_dir()
-        self.SQL_DIR = sql_dir
-
-    def get_option(self, option):
-        '''Get an option from the options dict.'''
-        return getattr(self._options, option)
-
-    def get_arg(self, index):
-        '''Get an arg from the arg list.'''
-        return self._args[index]
-
-    def print_help(self):
-        '''Wrapper around OptionParser.print_help.'''
-        return self._parser.print_help()
-
-    @property
-    def arg_count(self):
-        '''Return the number of args from the option parser.'''
-        return len(self._args)
-

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2009-03-18 19:34:07 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-03-06 20:36:09 +0000
@@ -17,7 +17,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import cgi
 import os
 import time
 
@@ -61,7 +60,7 @@
                 hl_lines = highlight(file_name, ''.join(file_lines))
                 hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
             else:
-                hl_lines = map(cgi.escape, file_lines)
+                hl_lines = file_lines
 
             change_cache = {}
 

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2009-03-17 22:38:57 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-12-05 18:52:44 +0000
@@ -17,13 +17,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import urllib
-
-try:
-    import simplejson
-except ImportError:
-    import json as simplejson
-
 from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
@@ -65,10 +58,7 @@
                 scan_list = revid_list[i:]
             change_list = scan_list[:pagesize]
             changes = list(history.get_changes(change_list))
-            data = {}
-            for i, c in enumerate(changes):
-                c.index = i
-                data[str(i)] = urllib.quote(urllib.quote(c.revid, safe=''))
+            history.add_changes(changes)
         except:
             self.log.exception('Exception fetching changes')
             raise HTTPServerError('Could not fetch changes')
@@ -81,6 +71,9 @@
             navigation.query = query
         util.fill_in_navigation(navigation)
 
+        # add parent & merge-point branch-nick info, in case it's useful
+        history.get_branch_nicks(changes)
+
         # Directory Breadcrumbs
         directory_breadcrumbs = (
             util.directory_breadcrumbs(
@@ -91,7 +84,6 @@
         return {
             'branch': self._branch,
             'changes': changes,
-            'data': simplejson.dumps(data),
             'util': util,
             'history': history,
             'revid': revid,

=== removed file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2009-03-28 14:26:37 +0000
+++ loggerhead/controllers/filediff_ui.py	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-from StringIO import StringIO
-import urllib
-
-from bzrlib import diff
-from bzrlib import errors
-from bzrlib import osutils
-
-from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
-
-def _process_diff(difftext):
-    chunks = []
-    chunk = None
-    for line in difftext.splitlines():
-        if len(line) == 0:
-            continue
-        if line.startswith('+++ ') or line.startswith('--- '):
-            continue
-        if line.startswith('@@ '):
-            # new chunk
-            if chunk is not None:
-                chunks.append(chunk)
-            chunk = util.Container()
-            chunk.diff = []
-            split_lines = line.split(' ')[1:3]
-            lines = [int(x.split(',')[0][1:]) for x in split_lines]
-            old_lineno = lines[0]
-            new_lineno = lines[1]
-        elif line.startswith(' '):
-            chunk.diff.append(util.Container(old_lineno=old_lineno,
-                                             new_lineno=new_lineno,
-                                             type='context',
-                                             line=line[1:]))
-            old_lineno += 1
-            new_lineno += 1
-        elif line.startswith('+'):
-            chunk.diff.append(util.Container(old_lineno=None,
-                                             new_lineno=new_lineno,
-                                             type='insert', line=line[1:]))
-            new_lineno += 1
-        elif line.startswith('-'):
-            chunk.diff.append(util.Container(old_lineno=old_lineno,
-                                             new_lineno=None,
-                                             type='delete', line=line[1:]))
-            old_lineno += 1
-        else:
-            chunk.diff.append(util.Container(old_lineno=None,
-                                             new_lineno=None,
-                                             type='unknown',
-                                             line=repr(line)))
-    if chunk is not None:
-        chunks.append(chunk)
-    return chunks
-
-
-def diff_chunks_for_file(repository, file_id, compare_revid, revid):
-    lines = {}
-    args = []
-    for r in (compare_revid, revid):
-        if r == 'null:':
-            lines[r] = []
-        else:
-            args.append((file_id, r, r))
-    for r, bytes_iter in repository.iter_files_bytes(args):
-        lines[r] = osutils.split_lines(''.join(bytes_iter))
-    buffer = StringIO()
-    try:
-        diff.internal_diff('', lines[compare_revid], '', lines[revid], buffer)
-    except errors.BinaryFile:
-        difftext = ''
-    else:
-        difftext = buffer.getvalue()
-
-    return _process_diff(difftext)
-
-
-class FileDiffUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.filediff'
-
-    def get_values(self, path, kwargs, headers):
-        history = self._history
-
-        revid = urllib.unquote(self.args[0])
-        compare_revid = urllib.unquote(self.args[1])
-        file_id = urllib.unquote(self.args[2])
-
-        repository = self._history._branch.repository
-        chunks = diff_chunks_for_file(
-            self._history._branch.repository, file_id, compare_revid, revid)
-
-        return {
-            'util': util,
-            'chunks': chunks,
-        }

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2009-03-19 00:44:05 +0000
+++ loggerhead/controllers/inventory_ui.py	2009-03-03 20:43:12 +0000
@@ -146,7 +146,8 @@
                 revno_url = 'head:'
             else:
                 revno_url = history.get_revno(revid)
-            history.add_branch_nicks(change)
+            # add parent & merge-point branch-nick info, in case it's useful
+            history.get_branch_nicks([ change ])
 
             # Create breadcrumb trail for the path within the branch
             branch_breadcrumbs = util.branch_breadcrumbs(path, rev_tree, 'files')

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-03-19 19:04:40 +0000
+++ loggerhead/controllers/revision_ui.py	2009-03-05 23:41:51 +0000
@@ -17,29 +17,158 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-try:
-    import simplejson
-except ImportError:
-    import json as simplejson
-import urllib
+from StringIO import StringIO
+
+import bzrlib.diff
+from bzrlib import errors
 
 from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
 from loggerhead.controllers import TemplatedBranchView
-from loggerhead.controllers.filediff_ui import diff_chunks_for_file
+from loggerhead.history import rich_filename
 
 
 DEFAULT_LINE_COUNT_LIMIT = 3000
 
-def dq(p):
-    return urllib.quote(urllib.quote(p, safe=''))
-
 
 class RevisionUI(TemplatedBranchView):
 
     template_path = 'loggerhead.templates.revision'
 
+    def _process_diff(self, diff):
+        # doesn't really need to be a method; could be static.
+        chunks = []
+        chunk = None
+        for line in diff.splitlines():
+            if len(line) == 0:
+                continue
+            if line.startswith('+++ ') or line.startswith('--- '):
+                continue
+            if line.startswith('@@ '):
+                # new chunk
+                if chunk is not None:
+                    chunks.append(chunk)
+                chunk = util.Container()
+                chunk.diff = []
+                split_lines = line.split(' ')[1:3]
+                lines = [int(x.split(',')[0][1:]) for x in split_lines]
+                old_lineno = lines[0]
+                new_lineno = lines[1]
+            elif line.startswith(' '):
+                chunk.diff.append(util.Container(old_lineno=old_lineno,
+                                                 new_lineno=new_lineno,
+                                                 type='context',
+                                                 line=line[1:]))
+                old_lineno += 1
+                new_lineno += 1
+            elif line.startswith('+'):
+                chunk.diff.append(util.Container(old_lineno=None,
+                                                 new_lineno=new_lineno,
+                                                 type='insert', line=line[1:]))
+                new_lineno += 1
+            elif line.startswith('-'):
+                chunk.diff.append(util.Container(old_lineno=old_lineno,
+                                                 new_lineno=None,
+                                                 type='delete', line=line[1:]))
+                old_lineno += 1
+            else:
+                chunk.diff.append(util.Container(old_lineno=None,
+                                                 new_lineno=None,
+                                                 type='unknown',
+                                                 line=repr(line)))
+        if chunk is not None:
+            chunks.append(chunk)
+        return chunks
+
+    def _parse_diffs(self, old_tree, new_tree, delta, specific_path):
+        """
+        Return a list of processed diffs, in the format::
+
+            list(
+                filename: str,
+                file_id: str,
+                chunks: list(
+                    diff: list(
+                        old_lineno: int,
+                        new_lineno: int,
+                        type: str('context', 'delete', or 'insert'),
+                        line: str,
+                    ),
+                ),
+            )
+        """
+        process = []
+        out = []
+
+        def include_specific_path(path):
+            return specific_path == path
+        def include_all_paths(path):
+            return True
+        if specific_path:
+            include_path = include_specific_path
+        else:
+            include_path = include_all_paths
+
+        for old_path, new_path, fid, \
+            kind, text_modified, meta_modified in delta.renamed:
+            if text_modified and include_path(new_path):
+                process.append((old_path, new_path, fid, kind))
+        for path, fid, kind, text_modified, meta_modified in delta.modified:
+            if include_path(path):
+                process.append((path, path, fid, kind))
+        for path, fid, kind in delta.added:
+            if file == 'kind' and include_path(path):
+                process.append((path, path, fid, kind))
+        for path, fid, kind in delta.removed:
+            if file == 'kind' and include_path(path):
+                process.append((path, path, fid, kind))
+
+        process.sort(key=lambda x:x[1])
+
+        for old_path, new_path, fid, kind in process:
+            try:
+                old_lines = old_tree.get_file_lines(fid)
+            except errors.NoSuchId:
+                old_lines = []
+            try:
+                new_lines = new_tree.get_file_lines(fid)
+            except errors.NoSuchId:
+                new_lines = []
+            buffer = StringIO()
+            if old_lines != new_lines:
+                try:
+                    bzrlib.diff.internal_diff(old_path, old_lines,
+                                              new_path, new_lines, buffer)
+                except bzrlib.errors.BinaryFile:
+                    diff = ''
+                else:
+                    diff = buffer.getvalue()
+            else:
+                diff = ''
+            out.append(util.Container(
+                filename=rich_filename(new_path, kind), file_id=fid,
+                chunks=self._process_diff(diff)))
+
+        return out
+
+    def get_changes_with_diff(self, change, compare_revid, specific_path):
+        h = self._history
+        if compare_revid is None:
+            if change.parents:
+                compare_revid = change.parents[0].revid
+            else:
+                compare_revid = 'null:'
+
+        rev_tree1 = h._branch.repository.revision_tree(compare_revid)
+        rev_tree2 = h._branch.repository.revision_tree(change.revid)
+        delta = rev_tree2.changes_from(rev_tree1)
+
+        changes = h.parse_delta(delta)
+
+        return changes, self._parse_diffs(
+            rev_tree1, rev_tree2, delta, specific_path)
+
     def get_values(self, path, kwargs, headers):
         h = self._history
         revid = self.get_revid()
@@ -68,32 +197,11 @@
         util.fill_in_navigation(navigation)
 
         change = h.get_changes([revid])[0]
-
-        if compare_revid is None:
-            file_changes = h.get_file_changes(change)
-        else:
-            file_changes = h.file_changes_for_revision_ids(
-                compare_revid, change.revid)
-
         if path in ('', '/'):
             path = None
-
-        link_data = {}
-        path_to_id = {}
-        if path:
-            item = [x for x in file_changes.text_changes if x.filename == path][0]
-            diff_chunks = diff_chunks_for_file(
-                self._history._branch.repository, item.file_id,
-                item.old_revision, item.new_revision)
-        else:
-            diff_chunks = None
-            for i, item in enumerate(file_changes.text_changes):
-                item.index = i
-                link_data['diff-' + str(i)] = '%s/%s/%s' % (
-                    dq(item.new_revision), dq(item.old_revision), dq(item.file_id))
-                path_to_id[item.filename] = 'diff-' + str(i)
-
-        h.add_branch_nicks(change)
+        change.changes, diffs = self.get_changes_with_diff(change, compare_revid, path)
+        # add parent & merge-point branch-nick info, in case it's useful
+        h.get_branch_nicks([change])
 
         # Directory Breadcrumbs
         directory_breadcrumbs = (
@@ -106,12 +214,8 @@
             'branch': self._branch,
             'revid': revid,
             'change': change,
-            'file_changes': file_changes,
-            'diff_chunks': diff_chunks,
-            'link_data': simplejson.dumps(link_data),
+            'diffs': diffs,
             'specific_path': path,
-            'json_specific_path': simplejson.dumps(path),
-            'path_to_id': simplejson.dumps(path_to_id),
             'start_revid': start_revid,
             'filter_file_id': filter_file_id,
             'util': util,

=== removed file 'loggerhead/controllers/revlog_ui.py'
--- loggerhead/controllers/revlog_ui.py	2009-03-19 00:44:05 +0000
+++ loggerhead/controllers/revlog_ui.py	1970-01-01 00:00:00 +0000
@@ -1,27 +0,0 @@
-import urllib
-
-from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
-
-
-class RevLogUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.revlog'
-
-    def get_values(self, path, kwargs, headers):
-        history = self._history
-
-        revid = urllib.unquote(self.args[0])
-
-        change = history.get_changes([revid])[0]
-        file_changes = history.get_file_changes(change)
-        history.add_branch_nicks(change)
-
-        return {
-            'branch': self._branch,
-            'entry': change,
-            'file_changes': file_changes,
-            'util': util,
-            'revid': revid,
-            'url': self._branch.context_url,
-        }

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2009-04-24 00:00:03 +0000
+++ loggerhead/history.py	2009-03-06 20:43:13 +0000
@@ -44,7 +44,6 @@
 
 import bzrlib
 import bzrlib.branch
-import bzrlib.delta
 import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
@@ -130,52 +129,6 @@
     def __len__(self):
         return len(self.revid_list)
 
-class FileChangeReporter(object):
-    def __init__(self, old_inv, new_inv):
-        self.added = []
-        self.modified = []
-        self.renamed = []
-        self.removed = []
-        self.text_changes = []
-        self.old_inv = old_inv
-        self.new_inv = new_inv
-
-    def revid(self, inv, file_id):
-        try:
-            return inv[file_id].revision
-        except bzrlib.errors.NoSuchId:
-            return 'null:'
-
-    def report(self, file_id, paths, versioned, renamed, modified,
-               exe_change, kind):
-        if modified not in ('unchanged', 'kind changed'):
-            if versioned == 'removed':
-                filename = rich_filename(paths[0], kind[0])
-            else:
-                filename = rich_filename(paths[1], kind[1])
-            self.text_changes.append(util.Container(
-                filename=filename, file_id=file_id,
-                old_revision=self.revid(self.old_inv, file_id),
-                new_revision=self.revid(self.new_inv, file_id)))
-        if versioned == 'added':
-            self.added.append(util.Container(
-                filename=rich_filename(paths[1], kind),
-                file_id=file_id, kind=kind[1]))
-        elif versioned == 'removed':
-            self.removed.append(util.Container(
-                filename=rich_filename(paths[0], kind),
-                file_id=file_id, kind=kind[0]))
-        elif renamed:
-            self.renamed.append(util.Container(
-                old_filename=rich_filename(paths[0], kind[0]),
-                new_filename=rich_filename(paths[1], kind[1]),
-                file_id=file_id,
-                text_modified=modified == 'modified'))
-        else:
-            self.modified.append(util.Container(
-                filename=rich_filename(paths[1], kind),
-                file_id=file_id))
-
 
 class History (object):
     """Decorate a branch to provide information for rendering.
@@ -466,7 +419,7 @@
 
         merge_point = []
         while True:
-            children = self._where_merged.get(revid, ())
+            children = self._where_merged.get(revid, [])
             nexts = []
             for child in children:
                 child_parents = self._revision_graph[child]
@@ -504,28 +457,31 @@
 
         return [d[revnos][1] for revnos in d.keys()]
 
-    def add_branch_nicks(self, change):
+    def get_branch_nicks(self, changes):
         """
-        given a 'change', fill in the branch nicks on all parents and merge
-        points.
+        given a list of changes from L{get_changes}, fill in the branch nicks
+        on all parents and merge points.
         """
         fetch_set = set()
-        for p in change.parents:
-            fetch_set.add(p.revid)
-        for p in change.merge_points:
-            fetch_set.add(p.revid)
+        for change in changes:
+            for p in change.parents:
+                fetch_set.add(p.revid)
+            for p in change.merge_points:
+                fetch_set.add(p.revid)
         p_changes = self.get_changes(list(fetch_set))
         p_change_dict = dict([(c.revid, c) for c in p_changes])
-        for p in change.parents:
-            if p.revid in p_change_dict:
-                p.branch_nick = p_change_dict[p.revid].branch_nick
-            else:
-                p.branch_nick = '(missing)'
-        for p in change.merge_points:
-            if p.revid in p_change_dict:
-                p.branch_nick = p_change_dict[p.revid].branch_nick
-            else:
-                p.branch_nick = '(missing)'
+        for change in changes:
+            # arch-converted branches may not have merged branch info :(
+            for p in change.parents:
+                if p.revid in p_change_dict:
+                    p.branch_nick = p_change_dict[p.revid].branch_nick
+                else:
+                    p.branch_nick = '(missing)'
+            for p in change.merge_points:
+                if p.revid in p_change_dict:
+                    p.branch_nick = p_change_dict[p.revid].branch_nick
+                else:
+                    p.branch_nick = '(missing)'
 
     def get_changes(self, revid_list):
         """Return a list of changes objects for the given revids.
@@ -570,6 +526,32 @@
 
         return [self._change_from_revision(rev) for rev in rev_list]
 
+    def _get_deltas_for_revisions_with_trees(self, revisions):
+        """Produce a list of revision deltas.
+
+        Note that the input is a sequence of REVISIONS, not revision_ids.
+        Trees will be held in memory until the generator exits.
+        Each delta is relative to the revision's lefthand predecessor.
+        (This is copied from bzrlib.)
+        """
+        required_trees = set()
+        for revision in revisions:
+            required_trees.add(revision.revid)
+            required_trees.update([p.revid for p in revision.parents[:1]])
+        trees = dict((t.get_revision_id(), t) for
+                     t in self._branch.repository.revision_trees(
+                         required_trees))
+        ret = []
+        for revision in revisions:
+            if not revision.parents:
+                old_tree = self._branch.repository.revision_tree(
+                    bzrlib.revision.NULL_REVISION)
+            else:
+                old_tree = trees[revision.parents[0].revid]
+            tree = trees[revision.revid]
+            ret.append(tree.changes_from(old_tree))
+        return ret
+
     def _change_from_revision(self, revision):
         """
         Given a bzrlib Revision, return a processed "change" for use in
@@ -582,15 +564,10 @@
 
         message, short_message = clean_message(revision.message)
 
-        try:
-            authors = revision.get_apparent_authors()
-        except AttributeError:
-            authors = [revision.get_apparent_author()]
-
         entry = {
             'revid': revision.revision_id,
             'date': commit_time,
-            'authors': authors,
+            'author': revision.get_apparent_author(),
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
             'comment': revision.message,
@@ -599,23 +576,22 @@
         }
         return util.Container(entry)
 
-    def get_file_changes_uncached(self, entry):
-        repo = self._branch.repository
-        if entry.parents:
-            old_revid = entry.parents[0].revid
-        else:
-            old_revid = bzrlib.revision.NULL_REVISION
-        return self.file_changes_for_revision_ids(old_revid, entry.revid)
-
-    def get_file_changes(self, entry):
+    def get_file_changes_uncached(self, entries):
+        delta_list = self._get_deltas_for_revisions_with_trees(entries)
+
+        return [self.parse_delta(delta) for delta in delta_list]
+
+    def get_file_changes(self, entries):
         if self._file_change_cache is None:
-            return self.get_file_changes_uncached(entry)
+            return self.get_file_changes_uncached(entries)
         else:
-            return self._file_change_cache.get_file_changes(entry)
-
-    def add_changes(self, entry):
-        changes = self.get_file_changes(entry)
-        entry.changes = changes
+            return self._file_change_cache.get_file_changes(entries)
+
+    def add_changes(self, entries):
+        changes_list = self.get_file_changes(entries)
+
+        for entry, changes in zip(entries, changes_list):
+            entry.changes = changes
 
     def get_file(self, file_id, revid):
         "returns (path, filename, data)"
@@ -627,7 +603,7 @@
             path = '/' + path
         return path, inv_entry.name, rev_tree.get_file_text(file_id)
 
-    def file_changes_for_revision_ids(self, old_revid, new_revid):
+    def parse_delta(self, delta):
         """
         Return a nested data structure containing the changes in a delta::
 
@@ -637,24 +613,31 @@
             modified: list(
                 filename: str,
                 file_id: str,
-            ),
-            text_changes: list((filename, file_id)),
+            )
         """
-        repo = self._branch.repository
-        if bzrlib.revision.is_null(old_revid) or \
-               bzrlib.revision.is_null(new_revid):
-            old_tree, new_tree = map(
-                repo.revision_tree, [old_revid, new_revid])
-        else:
-            old_tree, new_tree = repo.revision_trees([old_revid, new_revid])
-
-        reporter = FileChangeReporter(old_tree.inventory, new_tree.inventory)
-
-        bzrlib.delta.report_changes(new_tree.iter_changes(old_tree), reporter)
-
-        return util.Container(
-            added=sorted(reporter.added, key=lambda x:x.filename),
-            renamed=sorted(reporter.renamed, key=lambda x:x.new_filename),
-            removed=sorted(reporter.removed, key=lambda x:x.filename),
-            modified=sorted(reporter.modified, key=lambda x:x.filename),
-            text_changes=sorted(reporter.text_changes, key=lambda x:x.filename))
+        added = []
+        modified = []
+        renamed = []
+        removed = []
+
+        for path, fid, kind in delta.added:
+            added.append(util.Container(
+                filename=rich_filename(path, kind), file_id=fid, kind=kind))
+
+        for path, fid, kind, text_modified, meta_modified in delta.modified:
+            modified.append(util.Container(
+                filename=rich_filename(path, kind), file_id=fid))
+
+        for old_path, new_path, fid, kind, text_modified, meta_modified in \
+                delta.renamed:
+            renamed.append(util.Container(
+                old_filename=rich_filename(old_path, kind),
+                new_filename=rich_filename(new_path, kind), file_id=fid,
+                text_modified=text_modified))
+
+        for path, fid, kind in delta.removed:
+            removed.append(util.Container(
+                filename=rich_filename(path, kind), file_id=fid, kind=kind))
+
+        return util.Container(added=added, renamed=renamed,
+                              removed=removed, modified=modified)

=== added file 'loggerhead/lockfile.py'
--- loggerhead/lockfile.py	1970-01-01 00:00:00 +0000
+++ loggerhead/lockfile.py	2008-10-24 02:26:05 +0000
@@ -0,0 +1,84 @@
+#
+# Copyright (C) 2006  Robey Pointer <robey@lag.net>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import os
+import threading
+import time
+
+from loggerhead import util
+
+
+with_lock = util.with_lock('_tlock', 'LockFile')
+
+MAX_STALE_TIME = 5 * 60
+
+
+class LockFile (object):
+    """
+    simple lockfile implementation that mimics the API of threading.Lock, so
+    it can be used interchangably.  it's actually a reentrant lock, so the
+    lock may be acquired multiple times by the same thread, as long as it's
+    released an equal number of times.  unlike threading.Lock, this lock can
+    be used across processes.
+
+    this uses os.open(O_CREAT|O_EXCL), which apparently works even on windows,
+    but will not work over NFS, if anyone still uses that.  so don't put the
+    cache folder on an NFS server...
+    """
+
+    def __init__(self, filename):
+        self._filename = filename
+        # thread lock to maintain internal consistency
+        self._tlock = threading.Lock()
+        self._count = 0
+        if os.path.exists(filename):
+            # remove stale locks left over from a previous run
+            if time.time() - os.stat(filename).st_mtime > MAX_STALE_TIME:
+                os.remove(filename)
+
+    @with_lock
+    def _try_acquire(self):
+        if self._count > 0:
+            self._count += 1
+            return True
+        try:
+            fd = os.open(self._filename,
+                         os.O_WRONLY | os.O_CREAT | os.O_EXCL, 0600)
+            os.close(fd)
+            self._count += 1
+            return True
+        except OSError:
+            return False
+
+    def acquire(self):
+        # try over and over, sleeping on exponential backoff with
+        # an upper limit of about 5 seconds
+        pause = 0.1
+        #max_pause = 5.0
+        max_pause = 0.1
+        while True:
+            if self._try_acquire():
+                return
+            time.sleep(pause)
+            pause = min(pause * 2.0, max_pause)
+
+    @with_lock
+    def release(self):
+        self._count -= 1
+        if self._count == 0:
+            os.remove(self._filename)

=== modified file 'loggerhead/middleware/profile.py'
--- loggerhead/middleware/profile.py	2009-03-30 22:05:16 +0000
+++ loggerhead/middleware/profile.py	2008-11-14 06:48:20 +0000
@@ -1,11 +1,8 @@
 '''Profiling middleware for paste.'''
 import cgi
-import logging
-import sys
 import threading
 
 from bzrlib.lsprof import profile
-from guppy import hpy
 
 class LSProfMiddleware(object):
     '''Paste middleware for profiling with lsprof.'''
@@ -34,76 +31,3 @@
         finally:
             self.lock.release()
 
-
-class MemoryProfileMiddleware(object):
-    '''Paste middleware for profiling memory with heapy.'''
-
-    def __init__(self, app, limit=40):
-        self.app = app
-        self.lock = threading.Lock()
-
-        self.type2count = {}
-        self.type2all = {}
-        self.limit = limit
-
-    def update(self):
-        try:
-            obs = sys.getobjects(0)
-        except AttributeError:
-            logging.error(
-                'Python does not have debug symbols compiled.  Memory will '
-                'not be profiled.')
-            return
-        type2count = {}
-        type2all = {}
-        for o in obs:
-            all = sys.getrefcount(o)
-
-            if type(o) is str and o == '<dummy key>':
-                # avoid dictionary madness
-                continue
-            t = type(o)
-            if t in type2count:
-                type2count[t] += 1
-                type2all[t] += all
-            else:
-                type2count[t] = 1
-                type2all[t] = all
-
-        ct = [(type2count[t] - self.type2count.get(t, 0),
-               type2all[t] - self.type2all.get(t, 0),
-               t)
-              for t in type2count.iterkeys()]
-        ct.sort()
-        ct.reverse()
-        printed = False
-
-        logger = logging.getLogger('loggerhead-memprofile')
-        logger.debug('*' * 20)
-        logger.debug("Loggerhead Memory Profiling")
-        i = 0
-        for delta1, delta2, t in ct:
-            if delta1 or delta2:
-                if not printed:
-                    logger.debug("%-55s %8s %8s" % ('', 'insts', 'refs'))
-                    printed = True
-
-                logger.debug("%-55s %8d %8d" % (t, delta1, delta2))
-
-                i += 1
-                if i >= self.limit:
-                    break
-
-        self.type2count = type2count
-        self.type2all = type2all
-
-    def __call__(self, environ, start_response):
-        self.lock.acquire()
-        try:
-            # We don't want to be working with the static images
-            # TODO: There needs to be a better way to do this.
-            self.update()
-            return self.app(environ, start_response)
-        finally:
-            self.lock.release()
-

=== modified file 'loggerhead/search.py'
--- loggerhead/search.py	2009-04-17 01:50:05 +0000
+++ loggerhead/search.py	2008-11-05 00:50:06 +0000
@@ -17,17 +17,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-_mod_index = None
-def import_search():
-    global errors, _mod_index, FileTextHit, RevisionHit
-    if _mod_index is not None:
-        return
-    try:
-        from bzrlib.plugins.search import errors
-        from bzrlib.plugins.search import index as _mod_index
-        from bzrlib.plugins.search.index import FileTextHit, RevisionHit
-    except ImportError:
-        _mod_index = None
+import sets
+try:
+    from bzrlib.plugins.search import errors
+    from bzrlib.plugins.search import index as _mod_index
+    from bzrlib.plugins.search.index import FileTextHit, RevisionHit
+except ImportError:
+    _mod_index = None
 
 
 def search_revisions(branch, query_list, suggest=False):
@@ -40,7 +36,6 @@
     param suggest: Optional flag to request suggestions instead of results
     return: A list for results, either revision ids or terms
     """
-    import_search()
     if _mod_index is None:
         return None # None indicates could-not-search
     try:
@@ -64,6 +59,6 @@
                     revid_list.append(result.text_key[1])
                 elif isinstance(result, RevisionHit):
                     revid_list.append(result.revision_key[0])
-            return list(set(revid_list))
+            return list(sets.Set(revid_list))
     finally:
         index._branch.unlock()

=== removed file 'loggerhead/static/images/spinner.gif'
Binary files loggerhead/static/images/spinner.gif and loggerhead/static/images/spinner.gif differ
=== modified file 'loggerhead/static/javascript/changelog.js'
--- loggerhead/static/javascript/changelog.js	2009-03-31 21:11:38 +0000
+++ loggerhead/static/javascript/changelog.js	2009-02-20 03:30:31 +0000
@@ -53,23 +53,15 @@
     revlogs.each(
       function(item, i)
       {
-        var revid = revids[item.get('id').replace('log-', '')];
-        var collapsable = new Collapsable(
-          {
-            expand_icon: item.query('.expand_icon'),
-            open_node: item.query('.long_description'),
-            close_node: item.query('.short_description'),
-            source: global_path + '+revlog/' + revid,
-            loading: item.query('.loading'),
-            is_open: false
-          });
+        var item_slide = item.query('.revisioninfo');
+        var open_content  = new Array();
+        var close_content = new Array();
+        open_content.push(item.query('.long_description'));
+        close_content.push(item.query('.short_description'));
+        var expand_icon = item.query('.expand_icon');
+        var collapsable = new Collapsable(item_slide, expand_icon, open_content, close_content, false);
 
-        item.query('.expand_revisioninfo a').on(
-          'click',
-          function(e) {
-            e.preventDefault();
-            collapsable.toggle();
-          });
+        item.query('.expand_revisioninfo').on('click',function(){collapsable.toggle();});
         item.collapsable = collapsable;
       });
 

=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2009-04-01 15:28:21 +0000
+++ loggerhead/static/javascript/custom.js	2009-02-26 01:04:18 +0000
@@ -75,18 +75,30 @@
   setTimeout("Y.get('#search_terms').setStyle('display','none')", 300);
 }
 
-function Collapsable(config)
+function Collapsable(item, expand_icon, open_content, close_content, is_open)
 {
-  this.is_open = config.is_open;
-  this.open_node = config.open_node;
-  this.close_node = config.close_node;
-  this.expand_icon = config.expand_icon;
-  this.source = config.source;
-  this.loading = config.loading;
-  this.node_process = config.node_process;
-  this.container = null;
-  this.anim = null;
-  this._loading = false;
+  this.is_open = is_open;
+  this.item = item;
+  this.open_content  = open_content;
+  this.close_content = close_content;
+  this.expand_icon   = expand_icon;
+
+  if (this.is_open) {
+    this.height = item.get('region').height;
+  }
+  else {
+    this.height = null;
+  }
+
+  //var expander = new Fx.Slide(this.item, { duration: 200 } );
+  if (!this.is_open)
+  {
+    this.expand_icon.set('src',this.expand_icon.get('title'));
+  }
+  else
+  {
+    this.expand_icon.set('src',this.expand_icon.get('alt'));
+  }
 }
 
 function get_height(node) {
@@ -100,157 +112,56 @@
   return height;
 }
 
-Collapsable.prototype._animate = function (callback)
+Collapsable.prototype.open = function()
 {
-  if (this.anim) this.anim.stop();
+  if (this.height == null) {
+    this.height = get_height(this.item);
+  }
 
-  this.anim = new Y.Anim(
+  var anim = new Y.Anim(
     {
-      node: this.container,
+      node: this.item,
       from: {
-        marginBottom: this.container.getStyle('marginBottom')
+        height: 0
       },
       to: {
-        marginBottom: 0
+        height: this.height
       },
       duration: 0.2
     });
-
-  this.anim.run();
-  this.anim.on('end', this.animComplete, this, callback);
-}
-
-Collapsable.prototype._load_finished = function(tid, res, args)
-{
-  var l = res.responseText.split('\n');
-  l.splice(0, 1);
-  var newNode = Y.Node.create(l.join(''));
-  if (this.node_process)
-    this.node_process(newNode);
-  this.source = null;
-  newNode.setStyle('display', 'none');
-  this.loading.ancestor().insertBefore(newNode, this.loading);
-  var delta = this.loading.get('region').height - get_height(newNode);
-  newNode.setStyle('display', 'block');
-  this.container.setStyle('marginBottom', parseFloat(this.container.getStyle('marginBottom')) + delta);
-  this.loading.ancestor().removeChild(this.loading);
-  this._animate(args[0]);
-};
-
-Collapsable.prototype._ensure_container = function(callback)
-{
-  if (this.container == null) {
-    this.container = Y.Node.create('<div></div>');
-    if (this.closed_node) {
-      this.closed_node.ancestor().replaceChild(
-        this.container, this.closed_node);
-      this.container.appendChild(this.closed_node);
-      if (this.open_node) {
-        this.container.appendChild(this.open_node);
-      }
-    }
-    else {
-      this.open_node.ancestor().replaceChild(
-        this.container, this.open_node);
-      this.container.appendChild(this.open_node);
-    }
-    var outer = Y.Node.create('<div style="overflow:hidden;"></div>');
-    this.container.ancestor().replaceChild(outer, this.container);
-    outer.appendChild(this.container);
-  }
-}
-
-/* What happens when you click open.
- *
- * 1. The arrow flips to the expanded position.
- *
- * 2. If necessary, the div which will be running the animation is
- * created and the open/closed content stuffed into it (and has height
- * set to the height of the closed content).
- *
- * 3. The open content is shown and the closed content is closed.
- *
- * 4. The animation to expose all of the open content is started.
- *
- * 5. If we have to do ajax to load content, start the request.
- *
- * 6. When the request completes, parse the content into a node, run
- * the node_process callback over it and replace the spinner (assumed
- * to be appropriately contained in the open node) with the new node.
- *
- * 7. If the animation showing the open content has not completed,
- * stop it.
- *
- * 8. Start a new animation to show the rest of the new content.
- */
-
-Collapsable.prototype.open = function(callback)
-{
-  this.expand_icon.set('src', expanded_icon_path);
-
-  this._ensure_container();
-
-  var open_height = get_height(this.open_node);
-
-  var close_height;
-  if (this.close_node) {
-    close_height = this.close_node.get('region').height;
-  }
-  else {
-    close_height = 0;
-  }
-
-  this.container.setStyle('marginBottom', close_height - open_height);
-  if (this.close_node) {
-    this.close_node.setStyle('display', 'none');
-  }
-  this.open_node.setStyle('display', 'block');
-
-  this._animate(callback);
-
-  if (this.source) {
-    Y.io(
-      this.source,
-      {
-        on: {complete: this._load_finished},
-        arguments: [callback],
-        context: this
-      });
-    return;
-  }
-
-};
-
-Collapsable.prototype.animComplete = function(evt, callback)
-{
-  this.anim = null;
-  if (this._loading) return;
-  if (callback) callback();
+  anim.on('end', this.openComplete, this);
+  this.item.setStyle('height', 0);
+  this.item.setStyle('display', 'block');
+  anim.run();
+};
+
+Collapsable.prototype.openComplete = function()
+{
+  for (var i=0;i<this.open_content.length;++i)
+  {
+    this.open_content[i].setStyle('display','block');
+  }
+
+  for (var i=0;i<this.close_content.length;++i)
+  {
+    this.close_content[i].setStyle('display','none');
+  }
+
+  this.expand_icon.set('src',this.expand_icon.get('alt'));
   this.is_open = true;
 };
 
 Collapsable.prototype.close = function()
 {
-  this._ensure_container();
-
-  var open_height = this.open_node.get('region').height;
-
-  var close_height;
-  if (this.close_node) {
-    close_height = get_height(this.close_node);
-  }
-  else {
-    close_height = 0;
-  }
-
+  var item = this.item;
   var anim = new Y.Anim(
     {
-      node: this.container,
+      node: this.item,
       from: {
-        marginBottom: 0
+        height: this.height
       },
       to: {
-        marginBottom: close_height - open_height
+        height: 0
       },
       duration: 0.2
     });
@@ -259,18 +170,29 @@
 };
 
 Collapsable.prototype.closeComplete = function () {
-  this.open_node.setStyle('display', 'none');
-  if (this.close_node) {
-    this.close_node.setStyle('display', 'block');
-  }
-  this.container.setStyle('marginBottom', 0);
-  this.expand_icon.set('src', collapsed_icon_path);
+  this.item.setStyle('display', 'none');
+  var i;
+  for (i=0;i<this.open_content.length;++i)
+  {
+    this.open_content[i].setStyle('display','none');
+  }
+
+  for (i=0;i<this.close_content.length;++i)
+  {
+    this.close_content[i].setStyle('display','block');
+  }
+  this.expand_icon.set('src',this.expand_icon.get('title'));
   this.is_open = false;
 };
 
+Collapsable.prototype.isOpen = function()
+{
+  return this.is_open;
+};
+
 Collapsable.prototype.toggle = function()
 {
-  if (this.is_open)
+  if (this.isOpen())
   {
     this.close();
   }

=== modified file 'loggerhead/static/javascript/diff.js'
--- loggerhead/static/javascript/diff.js	2009-03-31 21:11:38 +0000
+++ loggerhead/static/javascript/diff.js	2009-02-26 02:06:31 +0000
@@ -41,6 +41,7 @@
   var removed = [];
   function clear_bufs(before) {
     if (!added.length && !removed.length) return;
+    Y.log('hai');
     var common = Math.min(added.length, removed.length);
     for (var i = 0; i < common; i++) {
       var a = added[i];
@@ -87,14 +88,13 @@
 
 function toggle_unified_sbs(event) {
   event.preventDefault();
-  var pts = Y.all(".pseudotable");
   if (unified) {
-    pts && pts.each(make_sbs);
+    Y.all(".pseudotable").each(make_sbs);
     unified = false;
     Y.get("#toggle_unified_sbs").set('innerHTML', "Show unified diffs");
   }
   else {
-    pts && pts.each(make_unified);
+    Y.all(".pseudotable").each(make_unified);
     unified = true;
     Y.get("#toggle_unified_sbs").set('innerHTML', "Show diffs side-by-side");
   }
@@ -104,7 +104,7 @@
 
 function toggle_expand_all_revisionview(action)
 {
-  var diffs = Y.all('.diff');
+  var diffs = Y.all('.diffBox');
   if (diffs == null) return;
   diffs.each(
     function(item, i)
@@ -143,62 +143,18 @@
   '#collapse_all a'
 );
 
-function node_process(node) {
-  if (!unified) {
-    node.get('children').filter('.pseudotable').each(make_sbs);
-  }
-}
-
-function zoom_to_diff (path) {
-  var collapsable = Y.get('#' + path_to_id[path]).collapsable;
-  if (!collapsable.is_open) {
-    collapsable.open(
-      function () {
-        window.location.hash = '#' + path;
-      });
-  }
-}
-
 Y.on(
   "domready", function () {
     Y.all(".show_if_js").removeClass("show_if_js");
-    if (!specific_path) {
-      Y.all("#list-files a").on(
-        'click',
-        function (e) {
-          e.preventDefault();
-          var path = decodeURIComponent(e.target.get('href').split('#')[1]);
-          window.location.hash = '#' + path;
-          zoom_to_diff(path);
-        });
-    }
-    var diffs = Y.all('.diff');
+    var diffs = Y.all('.diffBox');
     if (diffs == null) return;
     diffs.each(
       function(item, i)
       {
-        var source_url = null;
-        if (!specific_path)
-          source_url = global_path + '+filediff/' + link_data[item.get('id')];
-        item.query('.the-link').on(
-          'click',
-          function(e) {
-            e.preventDefault();
-            collapsable.toggle();
-          });
-        var collapsable = new Collapsable(
-          {
-            expand_icon: item.query('.expand_diff'),
-            open_node: item.query('.diffinfo'),
-            close_node: null,
-            source: source_url,
-            is_open: specific_path != null,
-            loading: item.query('.loading'),
-            node_process: node_process
-          });
-       item.collapsable=collapsable;
-       });
-    if (window.location.hash && !specific_path) {
-      zoom_to_diff(window.location.hash.substring(1));
-    }
+        var item_slide = item.next('.diffinfo');
+        var expand_icon = item.query( '.expand_diff' );
+        var collapsable = new Collapsable(item_slide, expand_icon, [], [], true);
+        item.query('.expand_diff').on('click', function(){collapsable.toggle();});
+        item.collapsable=collapsable;
+      });
   });

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-03-19 00:18:46 +0000
+++ loggerhead/templatefunctions.py	2009-03-07 07:29:26 +0000
@@ -38,30 +38,31 @@
 
 
 @templatefunc
-def file_change_summary(url, entry, file_changes, style='normal', currently_showing=None):
-    if style == 'fragment':
+def file_change_summary(url, entry, link_style='normal', currently_showing=None):
+    if link_style == 'fragment':
         def file_link(filename):
-            if currently_showing and filename == currently_showing:
-                return '<b><a href="#%s">%s</a></b>' % (
+            if currently_showing:
+                if filename == currently_showing:
+                    return '<b><a href="#%s">%s</a></b>' % (
+                        cgi.escape(filename), cgi.escape(filename))
+                else:
+                    return revision_link(url, entry.revno, filename)
+            else:
+                return '<a href="#%s">%s</a>' % (
                     cgi.escape(filename), cgi.escape(filename))
-            else:
-                return revision_link(
-                    url, entry.revno, filename, '#' + filename)
     else:
-        def file_link(filename):
-            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>'%(
-                url(['/revision', entry.revno]), '#' + filename, cgi.escape(filename),
-                cgi.escape(entry.revno), cgi.escape(filename))
+        file_link = lambda filename: revision_link(url, entry.revno, filename)
     return _pt('revisionfilechanges').expand(
-        entry=entry, file_changes=file_changes, file_link=file_link, **templatefunctions)
+        url=url, entry=entry, file_link=file_link,
+        currently_showing=currently_showing, **templatefunctions)
 
 
 @templatefunc
-def revisioninfo(url, branch, entry, file_changes=None, currently_showing=None):
+def revisioninfo(url, branch, entry, include_file_list=False, currently_showing=None):
     from loggerhead import util
     return _pt('revisioninfo').expand(
         url=url, change=entry, branch=branch, util=util,
-        file_changes=file_changes, currently_showing=currently_showing,
+        include_file_list=include_file_list, currently_showing=currently_showing,
         **templatefunctions)
 
 
@@ -119,7 +120,7 @@
         url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
-def revision_link(url, revno, path, frag=''):
-    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>'%(
-        url(['/revision', revno, path]), frag, cgi.escape(path),
-        cgi.escape(revno), cgi.escape(path))
+def revision_link(url, revno, path):
+    return '<a href="%s" title="View changes to %s in revision %s">%s</a>'%(
+        url(['/revision', revno, path]), cgi.escape(path), cgi.escape(revno),
+        cgi.escape(path))

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2009-03-06 09:57:54 +0000
+++ loggerhead/templates/annotate.pt	2009-03-02 00:10:26 +0000
@@ -65,7 +65,7 @@
               <a tal:condition="python:line.status=='changed'"
                  tal:content="python:util.trunc(line.change.revno)"
                  tal:attributes="href python:url(['/revision', line.change.revno], clear=1);
-                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, ', '.join(util.hide_emails(line.change.authors)), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
+                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
             </td>
             <td class="annoCont"><pre tal:content="structure line/text"></pre></td>
           </tr>

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2009-03-06 09:57:54 +0000
+++ loggerhead/templates/atom.pt	2008-06-26 20:42:15 +0000
@@ -17,8 +17,8 @@
     <id tal:content="python:branch.url(['/revision', entry.revno])">
       ID
     </id>
-    <author tal:repeat="author entry/authors">
-      <name tal:content="python:util.hide_email(author)">
+    <author>
+      <name tal:content="python:util.hide_email(entry.author)">
         author
       </name>
     </author>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2009-03-31 21:15:48 +0000
+++ loggerhead/templates/changelog.pt	2009-03-04 22:30:32 +0000
@@ -7,9 +7,6 @@
       <link rel="alternate" type="application/atom+xml"
             tal:attributes="href python:url(['/atom']);
                             title string:RSS feed for ${branch/friendly_name}" />
-    <script type="text/javascript">
-      var revids = <tal:block content="data" />;
-    </script>
       <script type="text/javascript"
               tal:attributes="src python:branch.static_url('/static/javascript/changelog.js')"></script>
     </metal:block>
@@ -70,46 +67,67 @@
       <table id="logentries">
         <tr class="logheader">
           <td class="revisionnumber">Rev</td>
-          <td class="expandcell show_if_js">&nbsp;</td>
+          <td class="expandcell">&nbsp;</td>
           <td class="summarycell">Summary</td>
-          <td class="authorcell">Authors</td>
+          <td class="authorcell">Author</td>
           <td class="datecell">Date</td>
           <td class="diffcell">Diff</td>
           <td class="downloadcell">Files</td>
         </tr>
         <tal:block tal:repeat="entry changes">
           <a tal:attributes="name string:entry-${entry/revno}"/>
-          <tr tal:attributes="class string:blueRow${entry/parity} revision_log; id string:log-${entry/index}">
+          <tr tal:attributes="class string:blueRow${entry/parity} revision_log">
             <td class="revnro revnolink"><a tal:attributes="title python:'Show revision '+entry.revno;
                                                             href  python:url(['/revision', entry.revno], clear=1)"
                                             tal:content="python:util.trunc(entry.revno)"></a>
             </td>
-            <td class="expcell show_if_js">
+            <td class="expcell">
               <div class="expand_revisioninfo">
-                <a href="#">
-                  <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
-                       class="expand_icon" />
-                </a>
+                <!-- So, this is interesting. I'm using "alt" to have the correct URL for the image of the expanded icon
+                     and "title" tag for the contracted URL of the image. This is a bit of a hack, but it's better than
+                     other approaches I tried  :)  -->
+                <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
+                                     alt python:branch.static_url('/static/images/treeExpanded.png');
+                                     title python:branch.static_url('/static/images/treeCollapsed.png')"
+                     class="expand_icon" />
               </div>
             </td>
-            <td class="summcell">
-              <div class="short_description">
+            <td class="summcell"><div tal:attributes="class string:short_description">
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"
                    tal:content="entry/short_comment"></a>
               </div>
-              <div class="long_description" style="display: none">
+              <div tal:attributes="class string:long_description;
+                                   style string:display:none">
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"
                    tal:content="structure python:util.fixed_width(entry.comment)"></a>
-                <div class="loading">
-                  <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-                </div>
+              </div>
+              <div class="revisioninfo" style="display:none;">
+                <ul class="expandrev">
+                  <li class="mfrom" tal:repeat="parent python:entry.parents[1:]">
+                    <span class="revnolink">
+                      <a tal:attributes="href python:url(['/changes', parent.revno])"
+                         tal:content="parent/revno"></a>
+                    </span>
+                    <a tal:condition="parent.branch_nick"
+                       tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
+                       tal:content="python:'(' + parent.branch_nick + ')'"
+                       title="Show history" class="link"></a>
+                  </li>
+                  <li class="mto" tal:repeat="merge_point entry/merge_points">
+                    <a tal:attributes="href python:url(['/changes'], start_revid=merge_point.revno)"
+                       tal:content="python:revno_with_nick(merge_point)"
+                       title="Show history" class="link"></a>
+                  </li>
+                  <li class="committerli" tal:content="python:util.hide_email(entry.author)"></li>
+                  <tal:block content="structure python:file_change_summary(url, entry)" />
+                </ul>
               </div>
             </td>
-            <td tal:content="python:util.trunc(util.hide_email(entry.authors[0]), 20)"
+            <td tal:content="python:util.trunc(util.hide_email(entry.author), 20)"
                 class="autcell"></td>
             <td class="date">
               <span tal:attributes="title python:util.date_time(entry.date)"

=== removed file 'loggerhead/templates/filediff.pt'
--- loggerhead/templates/filediff.pt	2009-04-01 15:28:21 +0000
+++ loggerhead/templates/filediff.pt	1970-01-01 00:00:00 +0000
@@ -1,25 +0,0 @@
-<div>
-  <div class="pseudotable unified"
-       tal:repeat="chunk chunks">
-
-    <tal:block condition="not:repeat/chunk/start">
-      <div class="pseudorow context-row">
-        <div class="lineNumber separate"></div>
-        <div class="lineNumber second separate"></div>
-        <div class="code separate"></div>
-        <div class="clear"><!-- --></div>
-      </div>
-    </tal:block>
-
-    <div tal:repeat="line chunk/diff"
-         tal:attributes="class string:pseudorow ${line/type}-row">
-      <div class="lineNumber first"
-           tal:content="structure python:util.fill_div(line.old_lineno)"></div>
-      <div class="lineNumber second"
-           tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-      <div tal:attributes="class string:code ${line/type}"
-           tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
-      <div class="clear"><!-- --></div>
-    </div>
-  </div>
-</div>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-04-07 18:26:03 +0000
+++ loggerhead/templates/macros.pt	2009-03-02 05:09:06 +0000
@@ -13,27 +13,34 @@
     </tal:comment>
     <script type="text/javascript">
       var global_path = <tal:block content="python:'\''+branch.url('/')+'\''" />;
-      var collapsed_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeCollapsed.png')+'\''" />;
-      var expanded_icon_path = <tal:block content="python:'\''+branch.static_url('/static/images/treeExpanded.png')+'\''" />;
     </script>
     <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('yui/yui-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('oop/oop-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('event/event-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('attribute/attribute-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('base/base-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('dom/dom-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('node/node-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('anim/anim-min.js')"></script>
-    <script type="text/javascript"
-            tal:attributes="src python:branch.yui_url('io/io-base-min.js')"></script>
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/yui/yui-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/oop/oop-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/event/event-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/attribute/attribute-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/base/base-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/dom/dom-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/node/node-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/anim/anim-min.js')"></script>
+    <script type="text/javascript"
+            tal:attributes="src
+            python:branch.static_url('/static/javascript/yui/build/io/io-base-min.js')"></script>
     <script type="text/javascript"
             tal:attributes="src python:branch.static_url('/static/javascript/custom.js')"></script>
     <metal:block metal:define-slot="header_extras" />

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2009-03-31 21:15:48 +0000
+++ loggerhead/templates/revision.pt	2009-03-05 22:56:59 +0000
@@ -11,11 +11,6 @@
               tal:attributes="href python:branch.static_url('/static/css/diff.css')"/>
         <script type="text/javascript"
                 tal:attributes="src python:branch.static_url('/static/javascript/diff.js')"></script>
-        <script type="text/javascript">
-          var link_data = <tal:b content="link_data" />;
-          var specific_path = <tal:b content="json_specific_path" />;
-          var path_to_id = <tal:b content="path_to_id" />;
-        </script>
       </metal:block>
     </head>
 
@@ -96,17 +91,15 @@
           </ul>
         </tal:we-are-comparing>
 
-        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, file_changes, specific_path)" />
-        <tal:specific-path condition="not:specific_path">
-          <p class="expand show_if_js" id="expand_all"><a href="#">
-              <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
-                   alt="expand all" /> expand all</a>
-          </p>
-          <p class="expand" id="collapse_all" style="display:none;"><a href="#">
-              <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
-                   alt="collapse all" /> collapse all</a>
-          </p>
-        </tal:specific-path>
+        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, 'fragment', specific_path)" />
+        <p class="expand" id="expand_all" style="display:none;"><a href="#">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
+                 alt="expand all" /> expand all</a>
+        </p>
+        <p class="expand show_if_js" id="collapse_all"><a href="#">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
+                 alt="collapse all" /> collapse all</a>
+        </p>
         <!-- Table -->
         <p class="expand show_if_js"><a id="toggle_unified_sbs" href="#">Show diffs side-by-side</a></p>
         <p class="codin"><img tal:attributes="src python:branch.static_url('/static/images/newCode.gif')" alt="added" /> added</p>
@@ -116,75 +109,46 @@
       </tal:block>
 
       <div metal:fill-slot="content">
-        <tal:block condition="specific_path">
-          <div class="diff">
-
-            <div  class="diffBox">
-              <a tal:attributes="href python:url(['/revision', change.revno, specific_path], clear=1);
-                                 id string:${specific_path};
-                                 title string:View changes to ${specific_path} only"
-                 class="the-link">
-                <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
-                     class="expand_diff"/>
-                <tal:b content="specific_path" />
-              </a>
-            </div>
-            <div style="overflow: hidden">
-              <div class="container">
-                <div class="loading" style="display:none">
-                  <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-                </div>
-                <div class="diffinfo">
-                  <div class="pseudotable unified"
-                       tal:repeat="chunk diff_chunks">
-
-                    <tal:block condition="not:repeat/chunk/start">
-                      <div class="pseudorow context-row">
-                        <div class="lineNumber separate"></div>
-                        <div class="lineNumber second separate"></div>
-                        <div class="code separate"></div>
-                        <div class="clear"><!-- --></div>
-                      </div>
-                    </tal:block>
-
-                    <div tal:repeat="line chunk/diff"
-                         tal:attributes="class string:pseudorow ${line/type}-row">
-                      <div class="lineNumber first"
-                           tal:content="structure python:util.fill_div(line.old_lineno)"></div>
-                      <div class="lineNumber second"
-                           tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-                      <div tal:attributes="class string:code ${line/type}"
-                           tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
-                      <div class="clear"><!-- --></div>
-                    </div>
-                  </div>
-                </div>
-              </div>
-            </div>
-          </div>
-        </tal:block>
-
-        <tal:block condition="not:specific_path">
-          <div class="diff"
-               tal:repeat="item file_changes/text_changes" tal:attributes="id string:diff-${item/index}">
-
-            <div  class="diffBox">
-              <a tal:attributes="href python:url(['/revision', change.revno, item.filename], clear=1);
-                                 id string:${item/filename};
-                                 title string:View changes to ${item/filename} only"
-                 class="the-link">
-                <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
-                     class="expand_diff" />
-                <tal:b content="item/filename" />
-              </a>
-            </div>
-            <div class="diffinfo"  style="display:none">
-              <div class="loading">
-                <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-              </div>
-            </div>
-          </div>
-        </tal:block>
+        <div class="diff"
+             tal:repeat="item diffs">
+
+          <div class="diffBox">
+            <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png');
+                                 title python:branch.static_url('/static/images/treeCollapsed.png');
+                                 alt python:branch.static_url('/static/images/treeExpanded.png')"
+                 class="expand_diff" />
+            <a tal:attributes="href python:url(['/revision', change.revno, item.filename], clear=1);
+                               id string:${item/filename};
+                               title string:View changes to ${item/filename} only"
+               tal:content="item/filename">
+            </a>
+          </div>
+          <div class="diffinfo">
+            <div class="pseudotable unified"
+                 tal:repeat="chunk item/chunks">
+
+              <tal:block condition="not:repeat/chunk/start">
+                <div class="pseudorow context">
+                  <div class="lineNumber separate"></div>
+                  <div class="lineNumber second separate"></div>
+                  <div class="code separate"></div>
+                  <div class="clear"><!-- --></div>
+                </div>
+              </tal:block>
+
+              <div tal:repeat="line chunk/diff"
+                   tal:attributes="class string:pseudorow ${line/type}-row">
+                <div class="lineNumber first"
+                     tal:content="structure python:util.fill_div(line.old_lineno)"></div>
+                <div class="lineNumber second"
+                     tal:content="structure python:util.fill_div(line.new_lineno)"></div>
+                <div tal:attributes="class string:code ${line/type}"
+                     tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
+                <div class="clear"><!-- --></div>
+              </div>
+            </div>
+          </div>
+        </div>
 
         <ul tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
             id="pages">

=== modified file 'loggerhead/templates/revisionfilechanges.pt'
--- loggerhead/templates/revisionfilechanges.pt	2009-03-19 00:05:41 +0000
+++ loggerhead/templates/revisionfilechanges.pt	2009-03-05 23:41:51 +0000
@@ -1,5 +1,5 @@
 <tal:block>
-  <ul tal:repeat="added file_changes/added">
+  <ul tal:repeat="added entry/changes/added">
     <tal:block condition="repeat/added/start">
       <li class="desc">files added:</li>
     </tal:block>
@@ -11,7 +11,7 @@
     </li>
   </ul>
 
-  <ul tal:repeat="removed file_changes/removed">
+  <ul tal:repeat="removed entry/changes/removed">
     <tal:block condition="repeat/removed/start">
       <li class="desc">files removed:</li>
     </tal:block>
@@ -23,7 +23,7 @@
     </li>
   </ul>
 
-  <ul tal:repeat="renamed file_changes/renamed">
+  <ul tal:repeat="renamed entry/changes/renamed">
     <tal:block condition="repeat/renamed/start">
       <li class="desc">files renamed:</li>
     </tal:block>
@@ -39,7 +39,7 @@
     </li>
   </ul>
 
-  <ul tal:repeat="item file_changes/modified">
+  <ul tal:repeat="item entry/changes/modified">
     <tal:block condition="repeat/item/start">
       <li class="desc">files modified:</li>
     </tal:block>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2009-03-19 00:18:46 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-03-05 22:56:59 +0000
@@ -1,6 +1,6 @@
 <div class="infoContainer">
     <div id="infTxt">
-        <div class="committer" tal:content="python:', '.join(util.hide_emails(change.authors))"></div>
+        <div class="committer" tal:content="python:util.hide_email(change.author)"></div>
         <div class="timer" tal:content="python:util.date_time(change.date)"></div>
         <div class="mfrom" tal:repeat="parent python:change.parents[1:]">
             <a tal:attributes="title string:Merged From ${parent/revno};
@@ -15,8 +15,8 @@
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
         <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>
     </div>
-    <ul id="list-files" tal:condition="file_changes">
-      <tal:block content="structure python:file_change_summary(url, change, file_changes, 'fragment', currently_showing)" />
+    <ul id="list-files" tal:condition="include_file_list">
+      <tal:block content="structure python:file_change_summary(url, change, 'fragment', currently_showing)" />
     </ul>
     <div class="clear"><!-- --></div>
 </div>

=== removed file 'loggerhead/templates/revlog.pt'
--- loggerhead/templates/revlog.pt	2009-03-31 15:23:54 +0000
+++ loggerhead/templates/revlog.pt	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-<div class="revisioninfo">
-  <ul class="expandrev">
-    <li class="mfrom" tal:repeat="parent python:entry.parents[1:]">
-      <span class="revnolink">
-        <a tal:attributes="href python:url(['/changes', parent.revno])"
-           tal:content="python:revno_with_nick(parent)"></a>
-      </span>
-    </li>
-    <li class="mto" tal:repeat="merge_point entry/merge_points">
-      <a tal:attributes="href python:url(['/changes', merge_point.revno])"
-         tal:content="python:revno_with_nick(merge_point)"
-         title="Show history" class="link"></a>
-    </li>
-    <li class="committerli" tal:content="python:', '.join(util.hide_emails(entry.authors))"></li>
-    <tal:block content="structure python:file_change_summary(url, entry, file_changes)" />
-  </ul>
-</div>

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2009-03-19 18:48:15 +0000
+++ loggerhead/tests/test_controllers.py	2009-02-26 06:31:24 +0000
@@ -53,9 +53,24 @@
         rev_ui.args = ['2']
         util.set_context({})
         self.assertIsInstance(
-            rev_ui.get_values('', {}, []),
+            rev_ui.get_values('2', {}, []),
             dict)
 
+    def test_get_changes_with_diff(self):
+        branch, rev_ui = self.make_bzrbranch_and_revision_ui_for_tree_shapes(
+            [('file', 'oldcontents'), ('file2', 'oldcontents')],
+            [('file', 'newcontents'), ('file2', 'oldcontents')])
+        change = rev_ui._history.get_changes([branch.last_revision()])[0]
+        changes, diffs = rev_ui.get_changes_with_diff(change, None, None)
+        self.assertEqual(1, len(diffs))
+
+    def test_get_changes_with_diff_specific_path(self):
+        branch, rev_ui = self.make_bzrbranch_and_revision_ui_for_tree_shapes(
+            [('file', 'oldcontents'), ('file2', 'oldcontents')],
+            [('file', 'newcontents'), ('file2', 'newcontents')])
+        change = rev_ui._history.get_changes([branch.last_revision()])[0]
+        changes, diffs = rev_ui.get_changes_with_diff(change, None, 'file')
+        self.assertEqual(1, len(diffs))
 
 class TestAnnotateUI(BasicTests):
 

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2009-04-02 20:32:12 +0000
+++ loggerhead/tests/test_corners.py	2009-02-10 01:58:31 +0000
@@ -34,16 +34,6 @@
         res = app.get('/revision/'+newrevid)
         res.mustcontain('executable')
 
-    def test_revision_escapes_commit_message(self):
-        """XXX."""
-        self.createBranch()
-
-        msg = '<b>hi</b>'
-        self.addFileAndCommit('myfilename', msg)
-        app = self.setUpLoggerhead()
-        res = app.get('/revision/1')
-        self.assertFalse(msg in res.body)
-
     def test_empty_commit_message(self):
         """Check that an empty commit message does not break the rendering."""
         self.createBranch()
@@ -56,7 +46,7 @@
         res = app.get('/changes')
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
-        res.mustcontain('1')
+        res.mustcontain('myfilename')
 
     def test_whitespace_only_commit_message(self):
         """Check that a whitespace-only commit message does not break the
@@ -71,4 +61,4 @@
         res = app.get('/changes')
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
-        res.mustcontain('1')
+        res.mustcontain('myfilename')

=== added file 'loggerhead/tests/test_filechangecache.py'
--- loggerhead/tests/test_filechangecache.py	1970-01-01 00:00:00 +0000
+++ loggerhead/tests/test_filechangecache.py	2008-10-24 02:26:05 +0000
@@ -0,0 +1,98 @@
+"""Tests for the FileChangeCache in loggerhead.changecache."""
+
+import shutil
+import tempfile
+
+from loggerhead.changecache import FileChangeCache
+
+
+class MockEntry(object):
+
+    def __init__(self, revid):
+        self.revid = revid
+
+
+class MockHistory(object):
+
+    def __init__(self):
+        self.fetched_revids = set()
+
+    def get_file_changes_uncached(self, entries):
+        output = []
+        for entry in entries:
+            self.fetched_revids.add(entry.revid)
+            output.append(entry.revid)
+        return output
+
+
+class TestFileChangeCache(object):
+
+    # setup_method and teardown_method are so i can run the tests with
+    # py.test and take advantage of the error reporting.
+
+    def setup_method(self, meth):
+        self.setUp()
+
+    def teardown_method(self, meth):
+        self.tearDown()
+
+    def setUp(self):
+        self.cache_folders = []
+
+    def tearDown(self):
+        for folder in self.cache_folders:
+            shutil.rmtree(folder)
+
+    def makeHistoryAndEntriesForRevids(self, revids, fill_cache_with=[]):
+        cache_folder = tempfile.mkdtemp()
+        self.cache_folders.append(cache_folder)
+        self.history = MockHistory()
+        self.cache = FileChangeCache(self.history, cache_folder)
+
+        self.entries = [MockEntry(revid) for revid in revids]
+
+        self.cache.get_file_changes([entry for entry in self.entries
+                                     if entry.revid in fill_cache_with])
+        self.history.fetched_revids.clear()
+
+    def test_empty_cache(self):
+        """An empty cache passes all the revids through to the history object.
+        """
+        revids = ['a', 'b']
+        self.makeHistoryAndEntriesForRevids(revids)
+
+        result = self.cache.get_file_changes(self.entries)
+
+        assert result == revids
+        assert self.history.fetched_revids == set(revids)
+
+    def test_full_cache(self):
+        """A full cache passes none of the revids through to the history
+        object.
+        """
+        revids = ['a', 'b']
+        self.makeHistoryAndEntriesForRevids(revids, fill_cache_with=revids)
+
+        result = self.cache.get_file_changes(self.entries)
+
+        assert result == revids
+        assert self.history.fetched_revids == set()
+
+    def test_partial_cache(self):
+        """A partially full cache passes some of the revids through to the
+        history object, and preserves the ordering of the argument list.
+        """
+        # To test the preservation of argument order code, we put the uncached
+        # revid at the beginning, middle and then end of the list of revids
+        # being asked for.
+        for i in range(3):
+            cached_revids = ['a', 'b']
+            revids = cached_revids[:]
+            revids.insert(i, 'uncached')
+            self.makeHistoryAndEntriesForRevids(
+                revids, fill_cache_with=cached_revids)
+
+            result = self.cache.get_file_changes(self.entries)
+            assert result == revids
+
+            assert self.history.fetched_revids == set(['uncached'])

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-04-02 20:32:12 +0000
+++ loggerhead/util.py	2009-03-03 21:39:54 +0000
@@ -181,14 +181,6 @@
         return '%s at %s' % (username, domains[-2])
     return '%s at %s' % (username, domains[0])
 
-def hide_emails(emails):
-    """
-    try to obscure any email address in a list of bazaar committers' names.
-    """
-    result = []
-    for email in emails:
-        result.append(hide_email(email))
-    return result
 
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
@@ -250,7 +242,7 @@
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
 
-    s = cgi.escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
+    s = s.expandtabs().replace(' ', NONBREAKING_SPACE)
 
     return HSC.clean(s).replace('\n', '<br/>')
 
@@ -449,6 +441,25 @@
     return new_decorator
 
 
+# common threading-lock decorator
+
+
+def with_lock(lockname, debug_name=None):
+    if debug_name is None:
+        debug_name = lockname
+
+    @decorator
+    def _decorator(unbound):
+
+        def locked(self, *args, **kw):
+            getattr(self, lockname).acquire()
+            try:
+                return unbound(self, *args, **kw)
+            finally:
+                getattr(self, lockname).release()
+        return locked
+    return _decorator
+
 
 @decorator
 def lsprof(f):

=== modified file 'loggerhead/wholehistory.py'
--- loggerhead/wholehistory.py	2009-04-24 00:00:03 +0000
+++ loggerhead/wholehistory.py	2008-12-05 20:09:14 +0000
@@ -71,9 +71,7 @@
         if _revision_info[revid][2] == 0:
             continue
         for parent in _revision_graph[revid]:
-            c = _where_merged.setdefault(parent, ())
-            if revid not in c:
-                _where_merged[parent] = c + (revid,)
+            _where_merged.setdefault(parent, set()).add(revid)
 
     log.info('built revision graph cache: %r secs' % (time.time() - z))
 

=== modified file 'serve-branches'
--- serve-branches	2009-04-17 00:14:16 +0000
+++ serve-branches	2009-02-24 21:13:30 +0000
@@ -19,6 +19,8 @@
 import os
 import sys
 
+from optparse import OptionParser
+
 from bzrlib.plugin import load_plugins
 
 from paste import httpserver
@@ -28,23 +30,54 @@
 from loggerhead import __version__
 from loggerhead.apps.filesystem import (
     BranchesFromFileSystemRoot, UserBranchesFromFileSystemRoot)
-from loggerhead.config import LoggerheadConfig
 from loggerhead.util import Reloader
 from loggerhead.apps.error import ErrorHandlerApp
 
 
+def command_line_parser():
+    parser = OptionParser("%prog [options] <path>")
+    parser.set_defaults(
+        user_dirs=False,
+        show_version=False,
+        log_folder=None,
+        )
+    parser.add_option("--user-dirs", action="store_true", dest="user_dirs",
+                      help="Serve user directories as ~user.")
+    parser.add_option("--trunk-dir", metavar="DIR",
+                      help="The directory that contains the trunk branches.")
+    parser.add_option("--port", dest="user_port",
+                      help=("Port Loggerhead should listen on "
+                            "(defaults to 8080)."))
+    parser.add_option("--host", dest="user_host",
+                      help="Host Loggerhead should listen on.")
+    parser.add_option("--prefix", dest="user_prefix",
+                      help="Specify host prefix.")
+    parser.add_option("--profile", action="store_true", dest="profile",
+                      help="Generate callgrind profile data to "
+                        "%d-stats.callgrind on each request.")
+    parser.add_option("--reload", action="store_true", dest="reload",
+                      help="Restarts the application when changing python"
+                           " files. Only used for development purposes.")
+    parser.add_option('--log-folder', dest="log_folder",
+                      type=str, help="The directory to place log files in.")
+    parser.add_option("--version", action="store_true", dest="show_version",
+                      help="Print the software version and exit")
+    return parser
+
+
 def main(args):
-    config = LoggerheadConfig()
+    parser = command_line_parser()
+    (options, args) = parser.parse_args(sys.argv[1:])
 
-    if config.get_option('show_version'):
+    if options.show_version:
         print "loggerhead %s" % __version__
         sys.exit(0)
 
-    if config.arg_count > 1:
-        config.print_help()
+    if len(args) > 1:
+        parser.print_help()
         sys.exit(1)
-    elif config.arg_count == 1:
-        path = config.get_arg(0)
+    elif len(args) == 1:
+        [path] = args
     else:
         path = '.'
 
@@ -52,31 +85,30 @@
         print "%s is not a directory" % path
         sys.exit(1)
 
-    if config.get_option('trunk_dir') and not config.get_option('user_dirs'):
+    if options.trunk_dir and not options.user_dirs:
         print "--trunk-dir is only valid with --user-dirs"
         sys.exit(1)
 
-    if config.get_option('reload'):
+    if options.reload:
         if Reloader.is_installed():
             Reloader.install()
         else:
             return Reloader.restart_with_reloader()
 
-    if config.get_option('user_dirs'):
-        if not config.get_option('trunk_dir'):
+    if options.user_dirs:
+        if not options.trunk_dir:
             print "You didn't specify a directory for the trunk directories."
             sys.exit(1)
-        app = UserBranchesFromFileSystemRoot(path, config)
+        app = UserBranchesFromFileSystemRoot(path, options.trunk_dir)
     else:
-        app = BranchesFromFileSystemRoot(path, config)
+        app = BranchesFromFileSystemRoot(path)
 
     # setup_logging()
     logging.basicConfig()
     logging.getLogger('').setLevel(logging.DEBUG)
     logger = getattr(app, 'log', logging.getLogger('loggerhead'))
-    if config.get_option('log_folder'):
-        logfile_path = os.path.join(
-            config.get_option('log_folder'), 'serve-branches.log')
+    if options.log_folder:
+        logfile_path = os.path.join(options.log_folder, 'serve-branches.log')
     else:
         logfile_path = 'serve-branches.log'
     logfile = logging.FileHandler(logfile_path, 'a')
@@ -85,26 +117,16 @@
     logfile.setFormatter(formatter)
     logfile.setLevel(logging.DEBUG)
     logger.addHandler(logfile)
-
-    if config.get_option('memory_profile'):
-        memprofile = logging.getLogger('loggerhead-memprofile')
-        memprofile.setLevel(logging.DEBUG)
-        memprofile.addHandler(logging.FileHandler('loggerhead-memprofile'))
-
     # setup_logging() #end
-
     app = TransLogger(app, logger=logger)
-    if config.get_option('profile'):
+    if options.profile:
         from loggerhead.middleware.profile import LSProfMiddleware
         app = LSProfMiddleware(app)
-    if config.get_option('memory_profile'):
-        from loggerhead.middleware.profile import MemoryProfileMiddleware
-        app = MemoryProfileMiddleware(app)
 
-    if not config.get_option('user_prefix'):
+    if not options.user_prefix:
         prefix = '/'
     else:
-        prefix = config.get_option('user_prefix')
+        prefix = options.user_prefix
         if not prefix.startswith('/'):
             prefix = '/' + prefix
 
@@ -129,15 +151,15 @@
     app = HTTPExceptionHandler(app)
     app = ErrorHandlerApp(app)
 
-    if not config.get_option('user_port'):
+    if not options.user_port:
         port = '8080'
     else:
-        port = config.get_option('user_port')
+        port = options.user_port
 
-    if not config.get_option('user_host'):
+    if not options.user_host:
         host = '0.0.0.0'
     else:
-        host = config.get_option('user_host')
+        host = options.user_host
 
     load_plugins()
 

